//***********************************************************************
//
//  MTDoc.h
//
//***********************************************************************

typedef struct tagTHREADPARMS {
    CWnd* pWnd;
    CBitmap* pBitmap;
    CPalette* pPalette;
    CCriticalSection* pCriticalSection;
    CEvent* pEvent;
} THREADPARMS;

class CMTDoc : public CDocument
{
    DECLARE_DYNCREATE (CMTDoc)

private:
    BOOL m_bWorking;
    HANDLE m_hThread;

public:
    CBitmap m_bitmap;
    CPalette m_palette;
    THREADPARMS m_threadParms;
    CCriticalSection m_criticalSection;
    CEvent m_event;

    CMTDoc ();
    virtual BOOL OnOpenDocument (LPCTSTR);
    virtual void DeleteContents ();
    virtual void Serialize (CArchive&);

    CBitmap* GetBitmap ();
    CPalette* GetPalette ();
    void ThreadFinished ();
    void ThreadAborted ();

protected:
    afx_msg void OnGrayScale ();
    afx_msg void OnUpdateGrayScaleUI (CCmdUI*);

    DECLARE_MESSAGE_MAP ()
};
