//***********************************************************************
//
//  MTView.cpp
//
//***********************************************************************

#include <afxwin.h>
#include <afxmt.h>
#include "Resource.h"
#include "MTDoc.h"
#include "MTView.h"

IMPLEMENT_DYNCREATE (CMTView, CScrollView)

void CMTView::OnInitialUpdate ()
{
    CScrollView::OnInitialUpdate ();

    CString string;
    CSize sizeTotal;

    CBitmap* pBitmap = GetDocument ()->GetBitmap ();
    if (pBitmap != NULL) {
        DIBSECTION ds;
        pBitmap->GetObject (sizeof (DIBSECTION), &ds);
        sizeTotal.cx = ds.dsBm.bmWidth;
        sizeTotal.cy = ds.dsBm.bmHeight;
        string.Format ("%d x %d, %d bpp", ds.dsBm.bmWidth,
            ds.dsBm.bmHeight, ds.dsBmih.biBitCount);
    }
    else {
        sizeTotal.cx = sizeTotal.cy = 0;
        string.Empty ();
    }

    AfxGetMainWnd ()->SendMessage (WM_USER_UPDATE_STATS, 0,
        (LPARAM) (LPCTSTR) string);
    SetScrollSizes (MM_TEXT, sizeTotal);
}

void CMTView::OnDraw (CDC* pDC)
{
    CMTDoc* pDoc = GetDocument ();
    CBitmap* pBitmap = pDoc->GetBitmap ();

    if (pBitmap != NULL) {
        CPalette* pOldPalette;
        CPalette* pPalette = pDoc->GetPalette ();

        if (pPalette != NULL) {
            pOldPalette = pDC->SelectPalette (pPalette, FALSE);
            pDC->RealizePalette ();
        }

        DIBSECTION ds;
        pBitmap->GetObject (sizeof (DIBSECTION), &ds);

        CDC memDC;
        memDC.CreateCompatibleDC (pDC);
        GetDocument ()->m_criticalSection.Lock ();
        CBitmap* pOldBitmap = memDC.SelectObject (pBitmap);

        pDC->BitBlt (0, 0, ds.dsBm.bmWidth, ds.dsBm.bmHeight, &memDC,
            0, 0, SRCCOPY);

        memDC.SelectObject (pOldBitmap);
        GetDocument ()->m_criticalSection.Unlock ();

        if (pPalette != NULL)
            pDC->SelectPalette (pPalette, FALSE);
    }
}
